package de.devloop.mavor.servlet;

import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;

import de.devloop.mavor.AuthenticatedServlet;
import de.devloop.mavor.Configuration;
import jakarta.servlet.ServletException;
import jakarta.servlet.annotation.WebServlet;
import jakarta.servlet.http.HttpServletRequest;
import jakarta.servlet.http.HttpServletResponse;

@WebServlet("/download/zip")
public class DownloadZip extends AuthenticatedServlet {

    private static final String PARAMETER_FILENAME = "file";

    private Configuration configuration;

    @Override
    public void init() throws ServletException {
        try {
            configuration = new Configuration();
        } catch (IOException e) {
            throw new ServletException("Configuration Error", e);
        }
    }

    @Override
    protected void doAuthenticatedGet(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
        File tempDir = new File(configuration.getTempDir());
        String zipFilename = req.getParameter(PARAMETER_FILENAME);
        File zipFile = new File(tempDir, zipFilename);

        if (zipFile.exists()) {
            if (zipFile.getParentFile().getCanonicalPath().equals(tempDir.getCanonicalPath())) {
                resp.addHeader("Content-Disposition", String.format("attachment; filename=\"%s\"", zipFilename));
                resp.setContentType("application/zip");
                resp.setContentLengthLong(zipFile.length());
                FileInputStream fileInputStream = new FileInputStream(zipFile);
                fileInputStream.transferTo(resp.getOutputStream());
                fileInputStream.close();
                zipFile.delete();
            } else {
                throw new ServletException("-.-");
            }
        } else {
            Main.redirectToMe(resp);
        }
    }
}
